Package ghidra.features.bsim.gui.filters

# Class NotArchitectureBSimFilterType

java.lang.Object
ghidra.features.bsim.gui.filters.BSimFilterType
ghidra.features.bsim.gui.filters.NotArchitectureBSimFilterType

All Implemented Interfaces:
  `Comparable<BSimFilterType>`

public class NotArchitectureBSimFilterType extends BSimFilterType
A BsimFilterType for filtering functions based on not matching a Ghidra computer architecture specification.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `XML_VALUE`

  ### Fields inherited from class ghidra.features.bsim.gui.filters.BSimFilterType

  `BLANK, hint, label, xmlval`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `NotArchitectureBSimFilterType()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `boolean`
  `evaluate(ExecutableRecord rec, String value)`
  Evaluate this filter for a specific ExecutableRecord and a specific filter -value-
  `void`
  `gatherElasticEffect(ElasticEffects effect, FilterAtom atom, IDElasticResolution resolution)`
  Gather pieces necessary to emit this filter as part of an elasticsearch query document
  `void`
  `gatherSQLEffect(SQLEffects effect, FilterAtom atom, IDSQLResolution resolution)`
  Gather all pieces to successfully convert this filter element into an SQL clause
  `IDSQLResolution`
  `generateIDSQLResolution(FilterAtom atom)`
  Construct a record describing the column id's that might need to be recovered before this filter element can be converted to an SQL clause
  `static List<String>`
  `getArchitectures()`
  `BSimValueEditor`
  `getEditor(List<String> initialValues, Callback listener)`
  `boolean`
  `orMultipleEntries()`

  ### Methods inherited from class ghidra.features.bsim.gui.filters.BSimFilterType

  `buildElasticCombinedClause, buildSQLCombinedClause, compareTo, equals, generateBsimFilters, generateIDElasticResolution, getBaseFilters, getBlank, getHint, getLabel, getXmlValue, hashCode, isBlank, isChildFilter, isLocal, isMultipleEntryAllowed, isValidValue, nameToType, normalizeValue, saveXml, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### XML_VALUE

    public static final String XML_VALUE
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### NotArchitectureBSimFilterType

    public NotArchitectureBSimFilterType()

- ## Method Details

  - ### gatherSQLEffect

    public void gatherSQLEffect(SQLEffects effect, FilterAtom atom, IDSQLResolution resolution) throws SQLException
    Description copied from class: `BSimFilterType`
    Gather all pieces to successfully convert this filter element into an SQL clause
    Specified by:
      `gatherSQLEffect` in class `BSimFilterType`
    Parameters:
      `effect` - is SQLEffects container for this filter elements pieces and others
      `atom` - holds the values for a particular instantiation of this filter element
      `resolution` - is the IDResolution containing relevant row ids for the filter, which must have been precalculated
    Throws:
      `SQLException` - for errors building the SQL clause

  - ### gatherElasticEffect

    public void gatherElasticEffect(ElasticEffects effect, FilterAtom atom, IDElasticResolution resolution) throws ElasticException
    Description copied from class: `BSimFilterType`
    Gather pieces necessary to emit this filter as part of an elasticsearch query document
    Specified by:
      `gatherElasticEffect` in class `BSimFilterType`
    Parameters:
      `effect` - is the ElasticEffects container holding the pieces
      `atom` - holds the values for a particular instantiation of this filter element
      `resolution` - contains relevant ids for the filter, which must have been precalculated
    Throws:
      `ElasticException` - for errors building the JSON subdocument

  - ### evaluate

    public boolean evaluate(ExecutableRecord rec, String value)
    Description copied from class: `BSimFilterType`
    Evaluate this filter for a specific ExecutableRecord and a specific filter -value-
    Specified by:
      `evaluate` in class `BSimFilterType`
    Parameters:
      `rec` - is the ExecutableRecord to filter against
      `value` - is the String value for an instantiated filter
    Returns:
      true if this element would allow the ExecutableRecord to pass the filter

  - ### generateIDSQLResolution

    public IDSQLResolution generateIDSQLResolution(FilterAtom atom)
    Description copied from class: `BSimFilterType`
    Construct a record describing the column id's that might need to be recovered before this filter element can be converted to an SQL clause
    Specified by:
      `generateIDSQLResolution` in class `BSimFilterType`
    Parameters:
      `atom` - is the specific FilterAtom to generate the record for
    Returns:
      the IDSQLResolution record or null if no ids need to be recovered

  - ### orMultipleEntries

    public boolean orMultipleEntries()
    Overrides:
      `orMultipleEntries` in class `BSimFilterType`
    Returns:
      true if multiple filters of this type should be OR'd. AND them otherwise.

  - ### getEditor

    public BSimValueEditor getEditor(List<String> initialValues, Callback listener)
    Overrides:
      `getEditor` in class `BSimFilterType`

  - ### getArchitectures

    public static List<String> getArchitectures()